#include <stdio.h>
#ifndef BERYL_PARAM
#define BERYL_PARAM 0.5
#endif


#define MODZ_DV (2*BERYL_PARAM + 1) * (2*BERYL_PARAM + 1)
#define MODY_DV (1/BERYL_PARAM + 1) * (1/BERYL_PARAM + 1)
#define MODZ_CV 1.0
#define MODY_CV (1 - BERYL_PARAM) * (1 - BERYL_PARAM)/(BERYL_PARAM*BERYL_PARAM)


short int est_dans_beryl(double zre, double zim, double yre, double yim, int maxiter) {
  int i;
  double re1tmp, re2tmp, im1tmp, modz, mody;
  for(i=0; i<=maxiter; i++) {
    re1tmp=zre;
    re2tmp=yre;
    im1tmp=zim;
    zre=BERYL_PARAM*(zre+yre);
    zim=BERYL_PARAM*(im1tmp+yim);
    yre=(re1tmp*re2tmp-im1tmp*yim);
    yim=(re1tmp*yim + re2tmp*im1tmp);
    modz=zre*zre+zim*zim;
    mody=yre*yre+yim*yim;
    if((modz<=MODZ_CV && mody<=MODY_CV) || mody<=0.000000001)	return 1;
    if(modz>MODZ_DV && mody>MODY_DV*modz)	return 0;
  }
  FILE *fichier;
  fichier = fopen("a_lire", "a");
  fprintf(fichier, "%i : %f + %f * i; %f + %f * i;\n", maxiter, zre, zim, yre, yim);
  fclose(fichier);
  return 1;
}
